/*
 *  cmpsi2.c
 *
 *  Implementation of cmpsi2, a 32-bit signed compare: r0r1 <=> r2r3
 *  Returns -1, 0, or 1, which might not be correct.
 *
 *  The contents of this file are subject to the Mozilla Public License
 *  Version 1.0 (the "License"); you may not use this file except in
 *  compliance with the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *
 *  The Original Code is Librcx code, released February 9, 1999.
 *
 *  The Initial Developer of the Original Code is Kekoa Proudfoot.
 *  Portions created by Kekoa Proudfoot are Copyright (C) 1999
 *  Kekoa Proudfoot. All Rights Reserved.
 *
 *  Contributor(s): Kekoa Proudfoot <kekoa@graphics.stanford.edu>
 */

__asm__ (
    ".section .text\n\t"
    ".global ___cmpsi2\n"
    "___cmpsi2:\n\t"
    /* r0r1 -= r2r3 */
    "sub.w r3,r1\n\t"
    "subx r2l,r0l\n\t"
    "subx r2h,r0h\n\t"
    "blt less\n"
    "beq zero\n"
    /* greater: r0r1 greater, return 1 */
    "mov.w #0x0001,r0\n\t"
    "rts\n"
    "less:\n\t"
    /* less: r2r3 greater, return -1 */
    "mov.w #0xffff,r0\n\t"
    "rts\n"
    "zero:\n\t"
    /* zero: r0r1 and r2r3 equal, return 0 */
    "sub.w r0,r0\n"
    "rts"
);
